From 30b2dea028cf8ed8c429641451de4f09467b65b1 Mon Sep 17 00:00:00 2001
From: =?UTF-8?q?Aur=C3=A9lien=20G=C3=A2teau?= <agateau@kde.org>
Date: Tue, 20 May 2014 15:02:00 +0200
Subject: [PATCH] Skip non-directory files inside the po/ directory

---
 modules/ECMPoQmTools.cmake                        | 10 +++++-----
 tests/ECMPoQmToolsTest/CMakeLists.txt             |  4 +++-
 tests/ECMPoQmToolsTest/po/no-po/placeholder       |  0
 tests/ECMPoQmToolsTest/po/should-not-be-installed |  0
 4 files changed, 8 insertions(+), 6 deletions(-)
 create mode 100644 tests/ECMPoQmToolsTest/po/no-po/placeholder
 create mode 100644 tests/ECMPoQmToolsTest/po/should-not-be-installed

diff --git a/modules/ECMPoQmTools.cmake b/modules/ECMPoQmTools.cmake
index e217dd3..3ce6958 100644
--- a/modules/ECMPoQmTools.cmake
+++ b/modules/ECMPoQmTools.cmake
@@ -188,13 +188,13 @@ function(ecm_install_po_files_as_qm podir)
         set(install_destination share/locale)
     endif()
 
-    file(GLOB lang_dirs "${podir}/*")
-    foreach(lang_dir ${lang_dirs})
-        file(GLOB po_files "${lang_dir}/*.po")
-        get_filename_component(lang ${lang_dir} NAME)
+    file(GLOB po_files "${podir}/*/*.po")
+    foreach(po_file ${po_files})
+        get_filename_component(po_dir ${po_file} DIRECTORY)
+        get_filename_component(lang ${po_dir} NAME)
         ecm_process_po_files_as_qm(
             ${lang} ALL
-            PO_FILES ${po_files}
+            PO_FILES ${po_file}
             INSTALL_DESTINATION ${install_destination}
         )
     endforeach()
diff --git a/tests/ECMPoQmToolsTest/CMakeLists.txt b/tests/ECMPoQmToolsTest/CMakeLists.txt
index 3dcb351..15351d2 100644
--- a/tests/ECMPoQmToolsTest/CMakeLists.txt
+++ b/tests/ECMPoQmToolsTest/CMakeLists.txt
@@ -24,7 +24,9 @@ ecm_process_po_files_as_qm(fr ALL
     PO_FILES only-process.po
 )
 
-# Should create a bunch of .qm files and install them in share/locale
+# Should create a bunch of .qm files and install them in share/locale.
+# Should ignore files directly under po/ as well as directories under po/ which
+# do not contain any .po files.
 ecm_install_po_files_as_qm(po)
 
 # Should create a bunch of .qm files and install them in
diff --git a/tests/ECMPoQmToolsTest/po/no-po/placeholder b/tests/ECMPoQmToolsTest/po/no-po/placeholder
new file mode 100644
index 0000000..e69de29
diff --git a/tests/ECMPoQmToolsTest/po/should-not-be-installed b/tests/ECMPoQmToolsTest/po/should-not-be-installed
new file mode 100644
index 0000000..e69de29
-- 
1.9.1

